#ifndef			_RAYCASTING_H
#define			_RAYCASTING_H

#include		<windows.h>

#include		<math.h>

//   OpenGL
#define			RC_COLOR_BUFFER_BIT		0x0001

// 
typedef		char			RCCHAR;
typedef		unsigned char	RCUCHAR;
typedef		int				RCINT;
typedef		float			RCFLOAT;

//   ,    -
#define			RC_DEPTH_CORRECT	0.0001

//  
#define			RC_LINE_SEGMENT		0x0001
#define			RC_CIRCLE			0x0002

// 
typedef struct	_strcRCVector2f
{
	float	v[ 2 ];		// x, y
}			strcRCVector2f;

// 
typedef struct	_strcRCColor
{
	RCUCHAR		c[ 4 ];		// r, g, b, a
}				strcRCColor;

//  
typedef struct	_strcRCRenderList
{
	int			iSSizeX, iSSizeY, iSSizeM, iSSizeM4, iSSizeXDiv2, iSSizeYDiv2;	// 
	HDC			hDc;	//  
	HDC			hDcBMP;	//  BMP
	HBITMAP		hBMP;	//  BMP
}				strcRCRenderList;

// 
typedef struct	_strcRCLine
{
	strcRCVector2f	vv[ 2 ];
	strcRCVector2f	vn;	
	strcRCVector2f	vc;	
}				strcRCLine;

// 
typedef struct	_strcRCCircle
{
	strcRCVector2f	vv;
	float			fRad;
}				strcRCCircle;

// 
typedef struct	_strcRCShape
{
	RCINT		iType;

	strcRCColor		cc;	

	strcRCCircle	crc;
	strcRCLine		lin;
}				strcRCShape;

//   
class			clRayCast
{

public:

	//  
	void		* bufData;

	//        
	#define		bufDataUChar ( ( unsigned char * )bufData )
	//        4-   int
	#define		bufDataUInt  ( ( unsigned int  * )bufData )

	//    
	strcRCVector2f	* dirData;
	//  
	strcRCShape		* shpData;
	//  
	int				iCountShapes;
	int				iActiveShape;

	//   
	strcRCColor		colBack;
	//   
	strcRCColor		colCurrent;
	//     
	strcRCRenderList	rlist;

	//     
	strcRCVector2f	vEye;
	strcRCVector2f	vDir;	//    

					clRayCast	( void );
	~				clRayCast	( void );

	// 
	void			rcInit	( HDC hDc, RCINT iSizeX, RCINT iSizeY );
	//   
	void			rcInitDir	( void );

	//  
	void			rcClear			( RCINT rtiMode );
	//    
	void			rcClearColor4b	( RCUCHAR r, RCUCHAR g, RCUCHAR b, RCUCHAR a );
	//    
	void			rcColor4b		( RCUCHAR r, RCUCHAR g, RCUCHAR b, RCUCHAR a );

	//   
	void			rcSetCount	( RCINT iCountShapes );
	//  
	void			rcLine		( RCFLOAT x0, RCFLOAT y0, RCFLOAT x1, RCFLOAT y1 );
	//  
	void			rcCircle	( RCFLOAT x, RCFLOAT y, RCFLOAT r );

	//   
	void			rcTrace			( void );

	//    
	void			rcSwapBuffers	( void );

	//      
	void			rcCamRot		( RCFLOAT ang );

	//  
	inline void		rcVecNormalize	( strcRCVector2f &v2f );	//  
	inline void		rcVecRotate		( RCFLOAT ang, strcRCVector2f &v2f );	//  
	inline float	rcVecLength		( strcRCVector2f v2f );	//  
	inline strcRCVector2f	rcVecSubtract( strcRCVector2f v0f, strcRCVector2f v1f );	//  

private:

};

#endif		// _RAYCASTING_H